Package com.sas.metadata.remote

# Interface ColumnRange

All Superinterfaces:
  `CMetadata`, `Column`, `Feature`, `LogicalColumn`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface ColumnRange extends Column
Represents a range of columns.

Attributes of ColumnRange are:

- `Start`
- `End`
- `Prefix`

Associations of ColumnRange are:

## Usage

To create an instance of this ColumnRange, use the `factory` create methods.
Example: create a ColumnRange with name "ColumnRange_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     ColumnRange myObject = (ColumnRange) factory.createComplexMetadataObject(objectStore, "ColumnRange_Object", MetadataObjects.COLUMNRANGE, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ATTRIBUTE_END_NAME`
  Constant used for the name of the End attribute.
  `static final String`
  `ATTRIBUTE_PREFIX_NAME`
  Constant used for the name of the Prefix attribute.
  `static final String`
  `ATTRIBUTE_START_NAME`
  Constant used for the name of the Start attribute.

  ### Fields inherited from interface com.sas.metadata.remote.Column

  `ASSOCIATION_ANALYTICCOLUMNS_NAME, ASSOCIATION_DISPLAYFORKEYS_NAME, ASSOCIATION_FOREIGNKEYASSOCIATIONS_NAME, ASSOCIATION_INDEXES_NAME, ASSOCIATION_KEYS_NAME, ASSOCIATION_QUERYCLAUSES_NAME, ASSOCIATION_TABLE_NAME, ASSOCIATION_UNIQUEKEYASSOCIATIONS_NAME, ASSOCIATION_XPATHS_NAME, ATTRIBUTE_BEGINPOSITION_NAME, ATTRIBUTE_ENDPOSITION_NAME, ATTRIBUTE_ISDISCRETE_NAME, ATTRIBUTE_ISNULLABLE_NAME, ATTRIBUTE_SASATTRIBUTE_NAME, ATTRIBUTE_SASCOLUMNLENGTH_NAME, ATTRIBUTE_SASCOLUMNNAME_NAME, ATTRIBUTE_SASCOLUMNTYPE_NAME, ATTRIBUTE_SASEXTENDEDCOLUMNTYPE_NAME, ATTRIBUTE_SASEXTENDEDLENGTH_NAME, ATTRIBUTE_SASPRECISION_NAME, ATTRIBUTE_SASSCALE_NAME, ATTRIBUTE_SORTORDER_NAME, ATTRIBUTE_SUMMARYROLE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Feature

  `ASSOCIATION_SOURCEFEATUREMAPS_NAME, ASSOCIATION_TARGETFEATUREMAPS_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.LogicalColumn

  `ATTRIBUTE_COLUMNLENGTH_NAME, ATTRIBUTE_COLUMNNAME_NAME, ATTRIBUTE_COLUMNTYPE_NAME, ATTRIBUTE_SASFORMAT_NAME, ATTRIBUTE_SASINFORMAT_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `getEnd()`
  Gets the `int` value of `End`
  `int`
  `getEndState()`
  Gets the Metadata State of `End`
  `String`
  `getPrefix()`
  Gets the `String` value of `Prefix`
  `int`
  `getPrefixMaxLength()`
  Gets the maximum length of `Prefix`
  `int`
  `getPrefixState()`
  Gets the Metadata State of `Prefix`
  `int`
  `getStart()`
  Gets the `int` value of `Start`
  `int`
  `getStartState()`
  Gets the Metadata State of `Start`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setEnd(int inEnd)`
  Sets the `End` value and sets the state to MetadataState.LOCAL.
  `void`
  `setEnd(int inEnd, int state)`
  Sets the `End` Metadata State.
  `void`
  `setEnd(String inEnd)`
  Sets the `End` value and sets the state to MetadataState.LOCAL.
  `void`
  `setEnd(String inEnd, int state)`
  Sets the `End` value and Metadata State.
  `void`
  `setEndState(int state)`
  Sets the Metadata State of `End`.
  `void`
  `setPrefix(String inPrefix)`
  Sets the `Prefix` value and sets the state to MetadataState.LOCAL.
  `void`
  `setPrefix(String inPrefix, int state)`
  Sets the `Prefix` Metadata State.
  `void`
  `setPrefixState(int state)`
  Sets the Metadata State of `Prefix`.
  `void`
  `setStart(int inStart)`
  Sets the `Start` value and sets the state to MetadataState.LOCAL.
  `void`
  `setStart(int inStart, int state)`
  Sets the `Start` Metadata State.
  `void`
  `setStart(String inStart)`
  Sets the `Start` value and sets the state to MetadataState.LOCAL.
  `void`
  `setStart(String inStart, int state)`
  Sets the `Start` value and Metadata State.
  `void`
  `setStartState(int state)`
  Sets the Metadata State of `Start`.

  ### Methods inherited from interface com.sas.metadata.remote.Column

  `getAnalyticColumns, getAnalyticColumns, getBeginPosition, getBeginPositionState, getDisplayForKeys, getDisplayForKeys, getEndPosition, getEndPositionState, getForeignKeyAssociations, getForeignKeyAssociations, getIndexes, getIndexes, getIsDiscrete, getIsDiscreteState, getIsNullable, getIsNullableState, getKeys, getKeys, getQueryClauses, getQueryClauses, getSASAttribute, getSASAttributeMaxLength, getSASAttributeState, getSASColumnLength, getSASColumnLengthState, getSASColumnName, getSASColumnNameMaxLength, getSASColumnNameState, getSASColumnType, getSASColumnTypeMaxLength, getSASColumnTypeState, getSASExtendedColumnType, getSASExtendedColumnTypeMaxLength, getSASExtendedColumnTypeState, getSASExtendedLength, getSASExtendedLengthState, getSASPrecision, getSASPrecisionState, getSASScale, getSASScaleState, getSortOrder, getSortOrderMaxLength, getSortOrderState, getSummaryRole, getSummaryRoleMaxLength, getSummaryRoleState, getTable, getTables, getTables, getUniqueKeyAssociations, getUniqueKeyAssociations, getXPaths, getXPaths, setAnalyticColumns, setAnalyticColumns, setBeginPosition, setBeginPosition, setBeginPosition, setBeginPosition, setBeginPositionState, setDisplayForKeys, setDisplayForKeys, setEndPosition, setEndPosition, setEndPosition, setEndPosition, setEndPositionState, setForeignKeyAssociations, setForeignKeyAssociations, setIndexes, setIndexes, setIsDiscrete, setIsDiscrete, setIsDiscrete, setIsDiscrete, setIsDiscreteState, setIsNullable, setIsNullable, setIsNullable, setIsNullable, setIsNullableState, setKeys, setKeys, setQueryClauses, setQueryClauses, setSASAttribute, setSASAttribute, setSASAttributeState, setSASColumnLength, setSASColumnLength, setSASColumnLength, setSASColumnLength, setSASColumnLengthState, setSASColumnName, setSASColumnName, setSASColumnNameState, setSASColumnType, setSASColumnType, setSASColumnTypeState, setSASExtendedColumnType, setSASExtendedColumnType, setSASExtendedColumnTypeState, setSASExtendedLength, setSASExtendedLength, setSASExtendedLength, setSASExtendedLength, setSASExtendedLengthState, setSASPrecision, setSASPrecision, setSASPrecision, setSASPrecision, setSASPrecisionState, setSASScale, setSASScale, setSASScale, setSASScale, setSASScaleState, setSortOrder, setSortOrder, setSortOrderState, setSummaryRole, setSummaryRole, setSummaryRoleState, setTable, setTables, setTables, setUniqueKeyAssociations, setUniqueKeyAssociations, setXPaths, setXPaths`

  ### Methods inherited from interface com.sas.metadata.remote.Feature

  `getSourceFeatureMaps, getSourceFeatureMaps, getTargetFeatureMaps, getTargetFeatureMaps, setSourceFeatureMaps, setSourceFeatureMaps, setTargetFeatureMaps, setTargetFeatureMaps`

  ### Methods inherited from interface com.sas.metadata.remote.LogicalColumn

  `getColumnLength, getColumnLengthState, getColumnName, getColumnNameMaxLength, getColumnNameState, getColumnType, getColumnTypeState, getSASFormat, getSASFormatMaxLength, getSASFormatState, getSASInformat, getSASInformatMaxLength, getSASInformatState, setColumnLength, setColumnLength, setColumnLength, setColumnLength, setColumnLengthState, setColumnName, setColumnName, setColumnNameState, setColumnType, setColumnType, setColumnType, setColumnType, setColumnTypeState, setSASFormat, setSASFormat, setSASFormatState, setSASInformat, setSASInformat, setSASInformatState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_START_NAME

    static final String ATTRIBUTE_START_NAME
    Constant used for the name of the Start attribute.

    Start: The starting position for the range.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_END_NAME

    static final String ATTRIBUTE_END_NAME
    Constant used for the name of the End attribute.

    End: The end position for a range.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_PREFIX_NAME

    static final String ATTRIBUTE_PREFIX_NAME
    Constant used for the name of the Prefix attribute.

    Prefix: The prefix for this range.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `Column`
    Specified by:
      `initializeRequiredObjects` in interface `Feature`
    Specified by:
      `initializeRequiredObjects` in interface `LogicalColumn`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    Specified by:
      `initializePredObjects` in interface `Column`
    Specified by:
      `initializePredObjects` in interface `Feature`
    Specified by:
      `initializePredObjects` in interface `LogicalColumn`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getStart

    int getStart() throws RemoteException
    Gets the `int` value of `Start`
    Returns:
      The `Start`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getStartState

    int getStartState() throws RemoteException
    Gets the Metadata State of `Start`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getEnd

    int getEnd() throws RemoteException
    Gets the `int` value of `End`
    Returns:
      The `End`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getEndState

    int getEndState() throws RemoteException
    Gets the Metadata State of `End`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPrefix

    String getPrefix() throws RemoteException
    Gets the `String` value of `Prefix`
    Returns:
      The `Prefix`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPrefixState

    int getPrefixState() throws RemoteException
    Gets the Metadata State of `Prefix`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPrefixMaxLength

    int getPrefixMaxLength() throws RemoteException
    Gets the maximum length of `Prefix`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### setStart

    void setStart(int inStart) throws RemoteException
    Sets the `Start` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inStart` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setStart

    void setStart(int inStart, int state) throws RemoteException
    Sets the `Start` Metadata State.
    Parameters:
      `inStart` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setStart

    void setStart(String inStart) throws RemoteException
    Sets the `Start` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inStart` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setStart

    void setStart(String inStart, int state) throws RemoteException
    Sets the `Start` value and Metadata State.
    Parameters:
      `inStart` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setStartState

    void setStartState(int state) throws RemoteException
    Sets the Metadata State of `Start`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEnd

    void setEnd(int inEnd) throws RemoteException
    Sets the `End` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inEnd` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEnd

    void setEnd(int inEnd, int state) throws RemoteException
    Sets the `End` Metadata State.
    Parameters:
      `inEnd` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEnd

    void setEnd(String inEnd) throws RemoteException
    Sets the `End` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inEnd` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEnd

    void setEnd(String inEnd, int state) throws RemoteException
    Sets the `End` value and Metadata State.
    Parameters:
      `inEnd` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEndState

    void setEndState(int state) throws RemoteException
    Sets the Metadata State of `End`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPrefix

    void setPrefix(String inPrefix) throws RemoteException
    Sets the `Prefix` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inPrefix` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPrefix

    void setPrefix(String inPrefix, int state) throws RemoteException
    Sets the `Prefix` Metadata State.
    Parameters:
      `inPrefix` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPrefixState

    void setPrefixState(int state) throws RemoteException
    Sets the Metadata State of `Prefix`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.